Bug 1752745 - rubygem-asciidoctor-pdf-1.5.0-0.10.alpha.18.fc31 is not installable
Summary: rubygem-asciidoctor-pdf-1.5.0-0.10.alpha.18.fc31 is not installable
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: rubygem-asciidoctor-pdf
Version: 32
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
Assignee: Christopher Brown
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: F31FailsToInstall
TreeView+ depends on / blocked
 
Reported: 2019-09-17 07:00 UTC by Zbigniew Jędrzejewski-Szmek
Modified: 2020-04-17 16:52 UTC (History)
8 users (show)

Fixed In Version: rubygem-asciidoctor-pdf-1.5.0-0.11.beta.6.fc31
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-04-17 16:52:13 UTC
Type: Bug


Attachments (Terms of Use)

Description Zbigniew Jędrzejewski-Szmek 2019-09-17 07:00:53 UTC
Description of problem:
On F31:
 Problem: conflicting requests
  - nothing provides (rubygem(concurrent-ruby) >= 1.1.0 with rubygem(concurrent-ruby) < 1.2) needed by rubygem-asciidoctor-pdf-1.5.0-0.10.alpha.18.fc31.noarch
  - nothing provides (rubygem(prawn-icon) >= 2.3.0 with rubygem(prawn-icon) < 2.4) needed by rubygem-asciidoctor-pdf-1.5.0-0.10.alpha.18.fc31.noarch
  - nothing provides (rubygem(treetop) >= 1.5.0 with rubygem(treetop) < 1.6) needed by rubygem-asciidoctor-pdf-1.5.0-0.10.alpha.18.fc31.noarch

This also affects upgrades from F30.

Comment 1 Ade Bradshaw 2019-09-19 05:43:31 UTC
I also had this. I had to remove the package before I could upgrade to F31 Beta

Comment 2 Kjell Irgens 2019-09-24 19:44:03 UTC
Ditto. This looks a lot like the same situation for Fedora 30: https://bugzilla.redhat.com/show_bug.cgi?id=1699514

Has upgrading to the upcoming 1.5.0 release been considered?

https://github.com/asciidoctor/asciidoctor-pdf/releases

Comment 3 Kjell Irgens 2019-10-18 04:52:45 UTC
OK, to sum up the problem:

                 Needed:            Available:                         
treetop          < 1.6              1.6.10
concurrent-ruby  > 1.1.0            1.0.5
prawn-icon       < 2.4.0            2.4.0

So some packages are too old while others are too new.  The way I see it, Fedora needs to make available multiple versions of rubygems that can be installed at the same time to support Ruby properly.  The newest version of asciidoctor-pdf needs e.g. prawn-icon > 2.5.0, so it would also not work.

Comment 4 François Cami 2019-10-18 11:14:21 UTC
I am failing to see a solution here.
Maybe moving asciidoctor-pdf to flatpak?
I need to hasten to say I have no intention of actually *doing* it.

Chris, what do you think?

Comment 5 Vít Ondruch 2019-10-18 11:14:40 UTC
(In reply to Kjell Irgens from comment #3)
> Fedora needs to make available multiple versions of rubygems

Fedora needs to check what dependencies are really required and relax the dependencies or apply patches where necessary.

Comment 6 Vít Ondruch 2019-10-18 11:18:59 UTC
(In reply to Vít Ondruch from comment #5)
> (In reply to Kjell Irgens from comment #3)
> > Fedora needs to make available multiple versions of rubygems
> 
> Fedora needs to check what dependencies are really required and relax the
> dependencies or apply patches where necessary.

Just FTR checking for example the treetop dependency, these are the last commits touching it:

https://github.com/asciidoctor/asciidoctor-pdf/commit/8b389ebd0bc9987403a077b8c6c561946b8f91e3
https://github.com/asciidoctor/asciidoctor-pdf/commit/77181c8078c5a5c58662a60adc32777a857c28d2
https://github.com/asciidoctor/asciidoctor-pdf/commit/e53945de0abc2835a8e61d5e44ea88d09707a6fd

There is no sign what so ever that just the treetop 1.5.x is required. The constraints appears to be just random.

Comment 7 Vít Ondruch 2019-10-18 11:21:39 UTC
(In reply to Vít Ondruch from comment #6)
But to be able to be at least a bit sure, the asciidoctor-pdf should first run its test suite during build. So there is definitely some work to do.

Comment 8 Christopher Brown 2019-10-18 12:34:19 UTC
Sorry, I've not seen any of these emails.

I'll take a look as soon as I can, thanks.

Comment 9 Christopher Brown 2019-10-20 05:42:30 UTC
I have enabled the test suite and done a scratch build of latest 1.5.0 beta (6 as of writing):

https://koji.fedoraproject.org/koji/taskinfo?taskID=38412336

This requires a separate source tarball as its not included in the gem however its building with only a few errors (639 examples, 16 failures) which I feel can be safely ignored - see above build log for more info but one example:

  3) Asciidoctor::PDF::Converter - Cover Page should not allow page size of PDF cover page to affect page size of document
     Failure/Error: (expect pdf.pages[0][:size]).to eql PDF::Core::PageGeometry::SIZES['LETTER']
       expected: [612.0, 792.0]
            got: [612, 792]
       (compared using eql?)
     # ./spec/cover_page_spec.rb:181:in `block (2 levels) in <top (required)>'


I have bumped prawn-icon to 2.5.0

@Vit - I have opened a PR to update concurrent to 1.1.5 for F31:

https://src.fedoraproject.org/rpms/rubygem-concurrent-ruby/pull-request/2

Comment 10 Fedora Update System 2019-10-20 06:20:34 UTC
FEDORA-2019-d48dcb1951 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-d48dcb1951

Comment 11 Fedora Update System 2019-10-20 17:13:36 UTC
rubygem-asciidoctor-pdf-1.5.0-0.11.beta.6.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-d48dcb1951

Comment 12 Christopher Brown 2019-10-21 07:45:40 UTC
Please note that I still need to sort the treetop dep here:

https://taskotron.fedoraproject.org/artifacts/all/60b57a8c-f34f-11e9-8f3a-52540077ca13/tests.yml/itemlogs/rubygem-asciidoctor-pdf-1.5.0-0.11.beta.6.fc31.x86_64.log

This doesn't appear to be a hard requirement from upstream:

https://github.com/asciidoctor/asciidoctor-pdf/blob/3870f7410de8e3bebc37d06d50c432ea5e402375/asciidoctor-pdf.gemspec#L45

@Vit - if you can take care of the concurrent bump that would be appreciated, then I believe we are there, with working test suite for the first time in a while too.

Thanks

Comment 13 Kjell Irgens 2019-10-21 11:14:30 UTC
1: Using a flatpak is not a good idea.  People can always use GEM directly if they are in a squeeze.

2: There is a reason treetop 1.5 is enforced: https://github.com/asciidoctor/asciidoctor-pdf/pull/1339

So one way to fix this (I have been doing that here locally) is to make a rubygem-treetop1.5 that installs in parallel with rubygem-treetop (1.6).

Of course, having a slow asciidoctor-pdf definitely beats having no asciidoctor-pdf.

--Kjell

Comment 14 Fedora Update System 2019-10-28 01:39:09 UTC
rubygem-asciidoctor-pdf-1.5.0-0.11.beta.6.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 15 Kjell Irgens 2019-10-28 21:55:58 UTC
Hm, this does not work for me at all.  I was glad to read that you moved up to the newest asciidoctor-pdf, but you do not seem to have updated any of the requrements.  So you now have 6 instead of 3 unmet requirements.  Supporting treetop 1.5.x should be easy, just take the SRPM from fedora30, change name to rubygem-treetop1.5 you have an RPM that installs in parallel with treetop 1.6.  None of the files are overlapping, so there are no patches involved or anything.  

kjell@localhost ~]$ sudo dnf install --refresh --enablerepo updates-testing rubygem-asciidoctor-pdf
Fedora Modular 31 - x86_64                                                                                                           37 kB/s |  19 kB     00:00    
Fedora Modular 31 - x86_64 - Updates                                                                                                 27 kB/s |  22 kB     00:00    
Fedora 31 - x86_64 - Test Updates                                                                                                    81 kB/s |  21 kB     00:00    
Fedora 31 - x86_64 - Test Updates                                                                                                   1.6 MB/s | 3.1 MB     00:01    
Fedora 31 - x86_64 - Updates                                                                                                         22 kB/s |  22 kB     00:00    
Fedora 31 - x86_64                                                                                                                   16 kB/s |  19 kB     00:01    
google-chrome                                                                                                                        16 kB/s | 1.3 kB     00:00    
RPM Fusion for Fedora 31 - Free - Updates                                                                                            15 kB/s |  12 kB     00:00    
RPM Fusion for Fedora 31 - Free                                                                                                      41 kB/s |  10 kB     00:00    
RPM Fusion for Fedora 31 - Nonfree - Updates                                                                                         55 kB/s |  12 kB     00:00    
RPM Fusion for Fedora 31 - Nonfree                                                                                                   46 kB/s |  11 kB     00:00    
Visual Studio Code                                                                                                                   11 kB/s | 2.9 kB     00:00    
Yarn Repository                                                                                                                      18 kB/s | 2.9 kB     00:00    
Error: 
 Problem: conflicting requests
  - nothing provides (rubygem(concurrent-ruby) >= 1.1.0 with rubygem(concurrent-ruby) < 1.2) needed by rubygem-asciidoctor-pdf-1.5.0-0.11.beta.6.fc31.noarch
  - nothing provides (rubygem(prawn-icon) >= 2.5.0 with rubygem(prawn-icon) < 2.6) needed by rubygem-asciidoctor-pdf-1.5.0-0.11.beta.6.fc31.noarch
  - nothing provides (rubygem(treetop) >= 1.5.0 with rubygem(treetop) < 1.6) needed by rubygem-asciidoctor-pdf-1.5.0-0.11.beta.6.fc31.noarch
  - nothing provides (rubygem(concurrent-ruby) >= 1.1.0 with rubygem(concurrent-ruby) < 1.2) needed by rubygem-asciidoctor-pdf-1.5.0-0.10.alpha.18.fc31.noarch
  - nothing provides (rubygem(treetop) >= 1.5.0 with rubygem(treetop) < 1.6) needed by rubygem-asciidoctor-pdf-1.5.0-0.10.alpha.18.fc31.noarch
  - nothing provides (rubygem(prawn-icon) >= 2.3.0 with rubygem(prawn-icon) < 2.4) needed by rubygem-asciidoctor-pdf-1.5.0-0.10.alpha.18.fc31.noarch
(try to add '--skip-broken' to skip uninstallable packages)

Comment 16 Christopher Brown 2019-10-29 09:53:32 UTC
There are still 3 unmet requirements, I have already bumped prawn-icon.

I plan to follow up with upstream treetop to see why performance has degraded but accept the performance hit for the moment and move to treetop 1.6. Or just remove the requirement as Vit has just submitted PR for.

So this leaves concurrent which I was hoping would be bumped, hence the needinfo on Vit.

Comment 17 Vít Ondruch 2019-10-29 12:15:06 UTC
(In reply to Christopher Brown from comment #16)
> I plan to follow up with upstream treetop to see why performance has
> degraded

Could you please elaborate?

> but accept the performance hit for the moment

Yep, this is good way forward. Better to work slowly then don't work at all :)

> and move to treetop
> 1.6. Or just remove the requirement as Vit has just submitted PR for.

The PR does not remove the dependency, it just relax the constraint. IOW instead of

~~~
Requires: rubygem(treetop) >= 1.5 with rubygem(treetop) < 1.6
~~~

there is now:

~~~
Requires: rubygem(treetop) >= 1.5 with rubygem(treetop) < 2
~~~


> So this leaves concurrent which I was hoping would be bumped, hence the
> needinfo on Vit.


Two things:

1) This is Rawhide ticket and Rawhide should work as soon as the build containing the changes from my PR [1] is available.
2) In the F31 context, I saw the rubygem-concurrent-ruby PR, but there was/is not provided convincing reason to merge it, because as far as I can tell, the same reasons as I provided for Treetop in comment 6 applies to the concurrent-ruby and all other dependencies. They are overly strict without any reasoning.




[1] https://src.fedoraproject.org/rpms/rubygem-asciidoctor-pdf/pull-request/6

Comment 18 Christopher Brown 2019-10-30 20:45:56 UTC
(In reply to Vít Ondruch from comment #17)
> (In reply to Christopher Brown from comment #16)
> > I plan to follow up with upstream treetop to see why performance has
> > degraded
> 
> Could you please elaborate?

https://github.com/asciidoctor/asciidoctor-pdf/pull/1339

> > but accept the performance hit for the moment
> 
> Yep, this is good way forward. Better to work slowly then don't work at all
> :)
> 
> > and move to treetop
> > 1.6. Or just remove the requirement as Vit has just submitted PR for.
> 
> The PR does not remove the dependency, it just relax the constraint. IOW
> instead of
> 
> ~~~
> Requires: rubygem(treetop) >= 1.5 with rubygem(treetop) < 1.6
> ~~~
> 
> there is now:
> 
> ~~~
> Requires: rubygem(treetop) >= 1.5 with rubygem(treetop) < 2
> ~~~

Yes, this is what I meant, I don't think the package would be functional without it actually. :)

> 
> > So this leaves concurrent which I was hoping would be bumped, hence the
> > needinfo on Vit.
> 
> 
> Two things:
> 
> 1) This is Rawhide ticket and Rawhide should work as soon as the build
> containing the changes from my PR [1] is available.
> 2) In the F31 context, I saw the rubygem-concurrent-ruby PR, but there
> was/is not provided convincing reason to merge it, because as far as I can
> tell, the same reasons as I provided for Treetop in comment 6 applies to the
> concurrent-ruby and all other dependencies. They are overly strict without
> any reasoning.

Ok, reason to merge would be:

1. Sort this issue out (not reason enough alone, no)
2. Minor update of package to latest for F31, I personally prefer to run latest

However, I'll just relax the constraint because GA is soon.

Comment 19 Fedora Update System 2019-10-30 22:33:29 UTC
FEDORA-2019-7a9c851071 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2019-7a9c851071

Comment 20 Christopher Brown 2019-10-30 22:42:41 UTC
Would appreciate feedback on this.

Have submitted prawn-icon as an update as well:

https://bodhi.fedoraproject.org/updates/FEDORA-2019-3e2d9ed943

Comment 21 Fedora Update System 2019-11-01 17:21:33 UTC
rubygem-asciidoctor-pdf-1.5.0-0.12.beta.6.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2019-7a9c851071

Comment 22 Eric Lavarde 2019-11-03 10:34:48 UTC
I still have issues upgrading from F30 to F31:

Error: 
 Problem 1: problem with installed package rubygem-asciidoctor-pdf-1.5.0-0.9.alpha.16.fc30.noarch
  - rubygem-asciidoctor-pdf-1.5.0-0.9.alpha.16.fc30.noarch does not belong to a distupgrade repository
  - nothing provides (rubygem(concurrent-ruby) >= 1.1.0 with rubygem(concurrent-ruby) < 1.2) needed by rubygem-asciidoctor-pdf-1.5.0-0.11.beta.6.fc31.noarch
  - nothing provides (rubygem(prawn-icon) >= 2.5.0 with rubygem(prawn-icon) < 2.6) needed by rubygem-asciidoctor-pdf-1.5.0-0.11.beta.6.fc31.noarch
  - nothing provides (rubygem(treetop) >= 1.5.0 with rubygem(treetop) < 1.6) needed by rubygem-asciidoctor-pdf-1.5.0-0.11.beta.6.fc31.noarch
  - nothing provides (rubygem(concurrent-ruby) >= 1.1.0 with rubygem(concurrent-ruby) < 1.2) needed by rubygem-asciidoctor-pdf-1.5.0-0.10.alpha.18.fc31.noarch
  - nothing provides (rubygem(treetop) >= 1.5.0 with rubygem(treetop) < 1.6) needed by rubygem-asciidoctor-pdf-1.5.0-0.10.alpha.18.fc31.noarch
 Problem 2: problem with installed package rubygem-asciidoctor-pdf-doc-1.5.0-0.9.alpha.16.fc30.noarch
  - package rubygem-asciidoctor-pdf-doc-1.5.0-0.11.beta.6.fc31.noarch requires rubygem-asciidoctor-pdf = 1.5.0-0.11.beta.6.fc31, but none of the providers can be installed
  - package rubygem-asciidoctor-pdf-doc-1.5.0-0.10.alpha.18.fc31.noarch requires rubygem-asciidoctor-pdf = 1.5.0-0.10.alpha.18.fc31, but none of the providers can be installed
  - rubygem-asciidoctor-pdf-doc-1.5.0-0.9.alpha.16.fc30.noarch does not belong to a distupgrade repository
  - nothing provides (rubygem(concurrent-ruby) >= 1.1.0 with rubygem(concurrent-ruby) < 1.2) needed by rubygem-asciidoctor-pdf-1.5.0-0.11.beta.6.fc31.noarch
  - nothing provides (rubygem(prawn-icon) >= 2.5.0 with rubygem(prawn-icon) < 2.6) needed by rubygem-asciidoctor-pdf-1.5.0-0.11.beta.6.fc31.noarch
  - nothing provides (rubygem(treetop) >= 1.5.0 with rubygem(treetop) < 1.6) needed by rubygem-asciidoctor-pdf-1.5.0-0.11.beta.6.fc31.noarch
  - nothing provides (rubygem(concurrent-ruby) >= 1.1.0 with rubygem(concurrent-ruby) < 1.2) needed by rubygem-asciidoctor-pdf-1.5.0-0.10.alpha.18.fc31.noarch
  - nothing provides (rubygem(treetop) >= 1.5.0 with rubygem(treetop) < 1.6) needed by rubygem-asciidoctor-pdf-1.5.0-0.10.alpha.18.fc31.noarch

If there is a mean to activate the testing repo while upgrading, then I'd be happy to give it a try, but I'd need a little help.

Comment 23 Christopher Brown 2019-11-03 11:59:40 UTC
(In reply to Eric Lavarde from comment #22)

> If there is a mean to activate the testing repo while upgrading, then I'd be
> happy to give it a try, but I'd need a little help.

Please click on the bodhi link in #c21 and it will explain it. Sorry for the breakage. If folks want to accelerate this then karma in bodhi is appreciated.

Comment 24 Eric Lavarde 2019-11-04 08:09:39 UTC
Will `--enablerepo=updates-testing --advisory=FEDORA-2019-7a9c851071` also work during a system-upgrade from F30 to F31? I wouldn't want to break my installation...

Comment 25 Eric Lavarde 2019-11-09 07:48:38 UTC
Answering my own: it will, it has!

karma added!

Comment 26 Fedora Update System 2019-11-09 21:20:41 UTC
rubygem-asciidoctor-pdf-1.5.0-0.12.beta.6.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.

Comment 27 Fedora Admin XMLRPC Client 2020-01-28 04:17:50 UTC
This package has changed maintainer in the Fedora.
Reassigning to the new maintainer of this component.

Comment 28 Ben Cotton 2020-02-11 17:24:37 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 32 development cycle.
Changing version to 32.


Note You need to log in before you can comment on or make changes to this bug.